%define modname   ivtv
%define modver    0.10.6
%define kernver   2.6.18-128.4.1.el5
%define kernstr   %(echo %{kernver} | tr '-' '_')

%define modtop    addon
%define moddir    %{modtop}/video

%define PAE       1
%define xen       1


Summary:          The Conexant CX23415/CX23416 Codec Chip Driver
Name:             ivtv-kmod
Version:          %{modver}
Release:          1.%{kernstr}%{?pext}
Epoch:            1
License:          GPL
Group:            System Environment/Kernel
Source0:          http://dl.ivtvdriver.org/%{modname}/archive/0.10.x/%{modname}-%{modver}.tar.gz
URL:              http://ivtvdriver.org/
Buildroot:        %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Vendor:           The IVTV Project
ExclusiveArch:    i686 x86_64

%description
The IVTV driver supports video hardware base on Conexant's CX23415/CX23416
codec chip such as the Hauppauge PVR 150/250/350/500 models.


%package       -n kmod-%{modname}
Summary:          Conexant CX23415/CX23416 Codec kernel module(s)
Group:            System Environment/Kernel
Provides:         kernel-modules = %{kernver}
Provides:         %{modname}-kmod = %{?epoch:%{epoch}:}%{version}-%{release}
Requires:         kernel-%{_target_cpu} = %{kernver}
Requires:         %{modname}-kmod-common >= %{modver}
Requires(post):   /sbin/depmod
Requires(postun): /sbin/depmod
BuildRequires:    kernel-devel-%{_target_cpu} = %{kernver}

%description   -n kmod-%{modname}
This package provides the Conexant CX23415/CX23416 Codec kernel modules built
for the Linux kernel %{kernver} for the %{_target_cpu} family of processors.


%package       -n kmod-%{modname}-PAE
Summary:          Conexant CX23415/CX23416 Codec kernel module(s)
Group:            System Environment/Kernel
Provides:         kernel-modules = %{kernver}PAE
Provides:         %{modname}-kmod = %{?epoch:%{epoch}:}%{version}-%{release}
Requires:         kernel-PAE-%{_target_cpu} = %{kernver}
Requires:         %{modname}-kmod-common >= %{modver}
Requires(post):   /sbin/depmod
Requires(postun): /sbin/depmod
%if %{PAE}
%ifarch i686
BuildRequires:    kernel-PAE-devel-%{_target_cpu} = %{kernver}
%endif
%endif

%description   -n kmod-%{modname}-PAE
This package provides the Conexant CX23415/CX23416 Codec kernel modules built
for the Linux kernel %{kernver}PAE for the %{_target_cpu} family of processors.


%package       -n kmod-%{modname}-xen
Summary:          Conexant CX23415/CX23416 Codec kernel module(s)
Group:            System Environment/Kernel
Provides:         kernel-modules = %{kernver}xen
Provides:         %{modname}-kmod = %{?epoch:%{epoch}:}%{version}-%{release}
Requires:         kernel-xen-%{_target_cpu} = %{kernver}
Requires:         %{modname}-kmod-common >= %{modver}
Requires(post):   /sbin/depmod
Requires(postun): /sbin/depmod
%if %{xen}
BuildRequires:    kernel-xen-devel-%{_target_cpu} = %{kernver}
%endif

%description   -n kmod-%{modname}-xen
This package provides the Conexant CX23415/CX23416 Codec kernel modules built
for the Linux kernel %{kernver}xen for the %{_target_cpu} family of processors.


%prep
%setup -q -n %{modname}-%{modver}


%build
BuildModule() {
  # Prepare environment
  if [ -n "$2" ]; then
    echo "BUILDING MODULE FOR $2 $1 KERNEL..."
    config="$2-$1"
  else
    echo "BUILDING MODULE FOR up $1 KERNEL..."
    config="$1"
  fi

  # Build module
  pushd driver
  export KDIR=%{_usrsrc}/kernels/%{kernver}-${config}

  %{__make} clean || :
  %{__make}
  popd

  %{__mkdir_p}        %{modname}-${config}.mod
  %{__mv} driver/*.ko %{modname}-${config}.mod
}

%if %{PAE}
%ifarch i686
BuildModule %{_target_cpu} PAE
%endif
%endif

%if %{xen}
BuildModule %{_target_cpu} xen
%endif

BuildModule %{_target_cpu}


%install
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_prefix}
%{__mkdir_p} ${RPM_BUILD_ROOT}/lib/modules/%{kernver}PAE/%{moddir}/%{modname}
%{__mkdir_p} ${RPM_BUILD_ROOT}/lib/modules/%{kernver}xen/%{moddir}/%{modname}
%{__mkdir_p} ${RPM_BUILD_ROOT}/lib/modules/%{kernver}/%{moddir}/%{modname}

%if %{PAE}
%ifarch i686
%{__install} -m 0744 %{modname}-PAE-%{_target_cpu}.mod/*.ko \
	${RPM_BUILD_ROOT}/lib/modules/%{kernver}PAE/%{moddir}/%{modname}
%endif
%endif

%if %{xen}
%{__install} -m 0744 %{modname}-xen-%{_target_cpu}.mod/*.ko \
	${RPM_BUILD_ROOT}/lib/modules/%{kernver}xen/%{moddir}/%{modname}
%endif

%{__install} -m 0744 %{modname}-%{_target_cpu}.mod/*.ko \
	${RPM_BUILD_ROOT}/lib/modules/%{kernver}/%{moddir}/%{modname}


%post -n kmod-%{modname}
/sbin/depmod -aeF /boot/System.map-%{kernver} %{kernver} >/dev/null || :

%post -n kmod-%{modname}-PAE
/sbin/depmod -aeF /boot/System.map-%{kernver}PAE %{kernver}PAE >/dev/null || :

%post -n kmod-%{modname}-xen
/sbin/depmod -aeF /boot/System.map-%{kernver}xen %{kernver}xen >/dev/null || :


%postun -n kmod-%{modname}
/sbin/depmod -aF /boot/System.map-%{kernver} %{kernver} &>/dev/null || :

%postun -n kmod-%{modname}-PAE
/sbin/depmod -aF /boot/System.map-%{kernver}PAE %{kernver}PAE &>/dev/null || :

%postun -n kmod-%{modname}-xen
/sbin/depmod -aF /boot/System.map-%{kernver}xen %{kernver}xen &>/dev/null || :


%clean
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}


%files -n kmod-%{modname}
%defattr(744,root,root)
/lib/modules/%{kernver}/%{modtop}

%if %{PAE}
%ifarch i686
%files -n kmod-%{modname}-PAE
%defattr(744,root,root)
/lib/modules/%{kernver}PAE/%{modtop}
%endif
%endif

%if %{xen}
%files -n kmod-%{modname}-xen
%defattr(744,root,root)
/lib/modules/%{kernver}xen/%{modtop}
%endif


%changelog
* Thu Aug 06 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1:0.10.6-1.2.6.18_128.4.1.el5
- New kernel version (2.6.18-128.4.1.el5)

* Wed Jul 15 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1:0.10.6-1.2.6.18_128.2.1.el5
- New kernel version (2.6.18-128.2.1.el5)

* Wed Jul 01 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1:0.10.6-1.2.6.18_128.1.16.el5
- New kernel version (2.6.18-128.1.16.el5)

* Sun Jun 21 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1:0.10.6-1.2.6.18_128.1.14.el5
- New kernel version (2.6.18-128.1.14.el5)

* Fri May 08 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1:0.10.6-1.2.6.18_128.1.10.el5
- New kernel version (2.6.18-128.1.10.el5)

* Fri Apr 03 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1:0.10.6-1.2.6.18_128.1.6.el5
- New kernel version (2.6.18-128.1.6.el5)

* Fri Apr 03 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1:0.10.6-1.2.6.18_128.1.1.el5
- New kernel version (2.6.18-128.1.1.el5)

* Fri Apr 03 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1:0.10.6-1.2.6.18_128.el5
- New kernel version (2.6.18-128.el5)

* Tue Mar 17 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1:0.10.6-1.2.6.18_92.1.22.el5
- New kernel version (2.6.18-92.1.22.el5)

* Tue Mar 17 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1:0.10.6-1.2.6.18_92.1.18.el5
- New kernel version (2.6.18-92.1.18.el5)

* Tue Mar 17 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1:0.10.6-1.2.6.18_92.1.17.el5
- New kernel version (2.6.18-92.1.17.el5)

* Tue Mar 17 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1:0.10.6-1.2.6.18_92.1.13.el5
- New kernel version (2.6.18-92.1.13.el5)

* Tue Mar 17 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1:0.10.6-1.2.6.18_92.1.10.el5
- Initial build
